/* -*- c++ -*- */
/*
 * Copyright 2003 Free Software Foundation, Inc.
 * 
 * This file is part of GNU Radio
 * 
 * GNU Radio is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * GNU Radio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNU Radio; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _GRCOMPLEXNCOSOURCE_H_
#define _GRCOMPLEXNCOSOURCE_H_

#include <GrSource.h>
#include <gr_nco.h>

class GrComplexNCOSource : public GrSource
{
 private:
  gr_nco<float,float>	d_nco;
  double		d_ampl;

 public:
  GrComplexNCOSource (double sampling_rate, double freq, double ampl);

  virtual const char *name () { return "GrComplexNCOSource"; }
  virtual int work2 (VrSampleRange output, void *o[]);
};

#endif /* _GRCOMPLEXNCOSOURCE_H_ */
