/* -*- c++ -*- */
/*
 * Copyright 2002 Free Software Foundation, Inc.
 * 
 * This file is part of GNU Radio
 * 
 * GNU Radio is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * GNU Radio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNU Radio; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _QA_ATSC_DATA_INTERLEAVER_H_
#define _QA_ATSC_DATA_INTERLEAVER_H_

#include <cppunit/TestCase.h>
#include <cppunit/TestCaller.h>
#include <cppunit/TestSuite.h>
#include <cppunit/TextTestResult.h>
#include <stdio.h>

#include <atsc_data_interleaver.h>

class qa_atsc_data_interleaver : public CppUnit::TestCase {

 public:

  void setUp (){
    outbound.reset ();
    inbound.reset ();
  }

  static void register_tests (CppUnit::TestSuite *suite)
  {
    suite->addTest (new CppUnit::TestCaller<qa_atsc_data_interleaver>
		    ("data_interleaver: t0", &qa_atsc_data_interleaver::t0));
    suite->addTest (new CppUnit::TestCaller<qa_atsc_data_interleaver>
		    ("data_interleaver: t1", &qa_atsc_data_interleaver::t1));
  }

 private:
  atsc_data_interleaver		outbound;
  atsc_data_deinterleaver	inbound;
  
  void t0 ();
  void t1 ();

  void init_test_packet (int counter, atsc_mpeg_packet_rs_encoded &out);
  void print_packet (FILE *fp, int frame_number, int field_number, int segment_number,
		     const atsc_mpeg_packet_rs_encoded &in);
  void chk_assert (const atsc_mpeg_packet_rs_encoded &expected,
		   const atsc_mpeg_packet_rs_encoded &actual);
};


#endif /* _QA_ATSC_DATA_INTERLEAVER_H_ */
