/* -*- c++ -*- */
/*
 * Copyright 2002 Free Software Foundation, Inc.
 * 
 * This file is part of GNU Radio
 * 
 * GNU Radio is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * GNU Radio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNU Radio; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _QA_CONVOLUTIONAL_INTERLEAVER_H_
#define _QA_CONVOLUTIONAL_INTERLEAVER_H_

#include <cppunit/TestCase.h>
#include <cppunit/TestCaller.h>
#include <cppunit/TestSuite.h>
#include <cppunit/TextTestResult.h>

#include <convolutional_interleaver.h>

class qa_convolutional_interleaver : public CppUnit::TestCase {
 private:
  convolutional_interleaver<int>	*intl;
  convolutional_interleaver<int>	*deintl;
  
 public:

  void tearDown (){
    delete intl;
    intl = 0;
    delete deintl;
    deintl = 0;
  }

  static void register_tests (CppUnit::TestSuite *suite)
  {
    suite->addTest (new CppUnit::TestCaller<qa_convolutional_interleaver>
		    ("conv: t0", &qa_convolutional_interleaver::t0));

    suite->addTest (new CppUnit::TestCaller<qa_convolutional_interleaver>
		    ("conv: t1", &qa_convolutional_interleaver::t1));

    suite->addTest (new CppUnit::TestCaller<qa_convolutional_interleaver>
		    ("conv: t2", &qa_convolutional_interleaver::t2));

    suite->addTest (new CppUnit::TestCaller<qa_convolutional_interleaver>
		    ("conv: t3", &qa_convolutional_interleaver::t3));

    suite->addTest (new CppUnit::TestCaller<qa_convolutional_interleaver>
		    ("conv: t4", &qa_convolutional_interleaver::t4));

  }

 private:

  void t0 ();
  void t1 ();
  void t2 ();
  void t3 ();
  void t4 ();

};


#endif /* _QA_CONVOLUTIONAL_INTERLEAVER_H_ */
